// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package tenant

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/devops/devops_models"
)

// NewPutTenantsParams creates a new PutTenantsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPutTenantsParams() *PutTenantsParams {
	return &PutTenantsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPutTenantsParamsWithTimeout creates a new PutTenantsParams object
// with the ability to set a timeout on a request.
func NewPutTenantsParamsWithTimeout(timeout time.Duration) *PutTenantsParams {
	return &PutTenantsParams{
		timeout: timeout,
	}
}

// NewPutTenantsParamsWithContext creates a new PutTenantsParams object
// with the ability to set a context for a request.
func NewPutTenantsParamsWithContext(ctx context.Context) *PutTenantsParams {
	return &PutTenantsParams{
		Context: ctx,
	}
}

// NewPutTenantsParamsWithHTTPClient creates a new PutTenantsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPutTenantsParamsWithHTTPClient(client *http.Client) *PutTenantsParams {
	return &PutTenantsParams{
		HTTPClient: client,
	}
}

/*
PutTenantsParams contains all the parameters to send to the API endpoint

	for the put tenants operation.

	Typically these are written to a http.Request.
*/
type PutTenantsParams struct {

	/* TenantRequest.

	   An array of Tenant records
	*/
	TenantRequest *devops_models.TenantRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the put tenants params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutTenantsParams) WithDefaults() *PutTenantsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the put tenants params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutTenantsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the put tenants params
func (o *PutTenantsParams) WithTimeout(timeout time.Duration) *PutTenantsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the put tenants params
func (o *PutTenantsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the put tenants params
func (o *PutTenantsParams) WithContext(ctx context.Context) *PutTenantsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the put tenants params
func (o *PutTenantsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the put tenants params
func (o *PutTenantsParams) WithHTTPClient(client *http.Client) *PutTenantsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the put tenants params
func (o *PutTenantsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithTenantRequest adds the tenantRequest to the put tenants params
func (o *PutTenantsParams) WithTenantRequest(tenantRequest *devops_models.TenantRequest) *PutTenantsParams {
	o.SetTenantRequest(tenantRequest)
	return o
}

// SetTenantRequest adds the tenantRequest to the put tenants params
func (o *PutTenantsParams) SetTenantRequest(tenantRequest *devops_models.TenantRequest) {
	o.TenantRequest = tenantRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PutTenantsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.TenantRequest != nil {
		if err := r.SetBodyParam(o.TenantRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
