// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/members/members_models"
)

// NewCreateEventParams creates a new CreateEventParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateEventParams() *CreateEventParams {
	return &CreateEventParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateEventParamsWithTimeout creates a new CreateEventParams object
// with the ability to set a timeout on a request.
func NewCreateEventParamsWithTimeout(timeout time.Duration) *CreateEventParams {
	return &CreateEventParams{
		timeout: timeout,
	}
}

// NewCreateEventParamsWithContext creates a new CreateEventParams object
// with the ability to set a context for a request.
func NewCreateEventParamsWithContext(ctx context.Context) *CreateEventParams {
	return &CreateEventParams{
		Context: ctx,
	}
}

// NewCreateEventParamsWithHTTPClient creates a new CreateEventParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateEventParamsWithHTTPClient(client *http.Client) *CreateEventParams {
	return &CreateEventParams{
		HTTPClient: client,
	}
}

/*
CreateEventParams contains all the parameters to send to the API endpoint

	for the create event operation.

	Typically these are written to a http.Request.
*/
type CreateEventParams struct {

	/* EventRequest.

	   An array of new Event records
	*/
	EventRequest *members_models.EventRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create event params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateEventParams) WithDefaults() *CreateEventParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create event params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateEventParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create event params
func (o *CreateEventParams) WithTimeout(timeout time.Duration) *CreateEventParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create event params
func (o *CreateEventParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create event params
func (o *CreateEventParams) WithContext(ctx context.Context) *CreateEventParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create event params
func (o *CreateEventParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create event params
func (o *CreateEventParams) WithHTTPClient(client *http.Client) *CreateEventParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create event params
func (o *CreateEventParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithEventRequest adds the eventRequest to the create event params
func (o *CreateEventParams) WithEventRequest(eventRequest *members_models.EventRequest) *CreateEventParams {
	o.SetEventRequest(eventRequest)
	return o
}

// SetEventRequest adds the eventRequest to the create event params
func (o *CreateEventParams) SetEventRequest(eventRequest *members_models.EventRequest) {
	o.EventRequest = eventRequest
}

// WriteToRequest writes these params to a swagger request
func (o *CreateEventParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.EventRequest != nil {
		if err := r.SetBodyParam(o.EventRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
