// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package tenants

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_models"
)

// PutTenantsReader is a Reader for the PutTenants structure.
type PutTenantsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutTenantsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutTenantsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutTenantsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutTenantsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutTenantsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutTenantsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutTenantsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPutTenantsOK creates a PutTenantsOK with default headers values
func NewPutTenantsOK() *PutTenantsOK {
	return &PutTenantsOK{}
}

/*
PutTenantsOK describes a response with status code 200, with default header values.

Response with Tenant objects
*/
type PutTenantsOK struct {
	Payload *sfgate_models.TenantResponse
}

// IsSuccess returns true when this put tenants o k response has a 2xx status code
func (o *PutTenantsOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this put tenants o k response has a 3xx status code
func (o *PutTenantsOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put tenants o k response has a 4xx status code
func (o *PutTenantsOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this put tenants o k response has a 5xx status code
func (o *PutTenantsOK) IsServerError() bool {
	return false
}

// IsCode returns true when this put tenants o k response a status code equal to that given
func (o *PutTenantsOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the put tenants o k response
func (o *PutTenantsOK) Code() int {
	return 200
}

func (o *PutTenantsOK) Error() string {
	return fmt.Sprintf("[PUT /tenants][%d] putTenantsOK  %+v", 200, o.Payload)
}

func (o *PutTenantsOK) String() string {
	return fmt.Sprintf("[PUT /tenants][%d] putTenantsOK  %+v", 200, o.Payload)
}

func (o *PutTenantsOK) GetPayload() *sfgate_models.TenantResponse {
	return o.Payload
}

func (o *PutTenantsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.TenantResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutTenantsUnauthorized creates a PutTenantsUnauthorized with default headers values
func NewPutTenantsUnauthorized() *PutTenantsUnauthorized {
	return &PutTenantsUnauthorized{}
}

/*
PutTenantsUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PutTenantsUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *sfgate_models.Error
}

// IsSuccess returns true when this put tenants unauthorized response has a 2xx status code
func (o *PutTenantsUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put tenants unauthorized response has a 3xx status code
func (o *PutTenantsUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put tenants unauthorized response has a 4xx status code
func (o *PutTenantsUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this put tenants unauthorized response has a 5xx status code
func (o *PutTenantsUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this put tenants unauthorized response a status code equal to that given
func (o *PutTenantsUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the put tenants unauthorized response
func (o *PutTenantsUnauthorized) Code() int {
	return 401
}

func (o *PutTenantsUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /tenants][%d] putTenantsUnauthorized  %+v", 401, o.Payload)
}

func (o *PutTenantsUnauthorized) String() string {
	return fmt.Sprintf("[PUT /tenants][%d] putTenantsUnauthorized  %+v", 401, o.Payload)
}

func (o *PutTenantsUnauthorized) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PutTenantsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutTenantsForbidden creates a PutTenantsForbidden with default headers values
func NewPutTenantsForbidden() *PutTenantsForbidden {
	return &PutTenantsForbidden{}
}

/*
PutTenantsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PutTenantsForbidden struct {
	AccessControlAllowOrigin string

	Payload *sfgate_models.Error
}

// IsSuccess returns true when this put tenants forbidden response has a 2xx status code
func (o *PutTenantsForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put tenants forbidden response has a 3xx status code
func (o *PutTenantsForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put tenants forbidden response has a 4xx status code
func (o *PutTenantsForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this put tenants forbidden response has a 5xx status code
func (o *PutTenantsForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this put tenants forbidden response a status code equal to that given
func (o *PutTenantsForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the put tenants forbidden response
func (o *PutTenantsForbidden) Code() int {
	return 403
}

func (o *PutTenantsForbidden) Error() string {
	return fmt.Sprintf("[PUT /tenants][%d] putTenantsForbidden  %+v", 403, o.Payload)
}

func (o *PutTenantsForbidden) String() string {
	return fmt.Sprintf("[PUT /tenants][%d] putTenantsForbidden  %+v", 403, o.Payload)
}

func (o *PutTenantsForbidden) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PutTenantsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutTenantsNotFound creates a PutTenantsNotFound with default headers values
func NewPutTenantsNotFound() *PutTenantsNotFound {
	return &PutTenantsNotFound{}
}

/*
PutTenantsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PutTenantsNotFound struct {
	AccessControlAllowOrigin string

	Payload *sfgate_models.Error
}

// IsSuccess returns true when this put tenants not found response has a 2xx status code
func (o *PutTenantsNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put tenants not found response has a 3xx status code
func (o *PutTenantsNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put tenants not found response has a 4xx status code
func (o *PutTenantsNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this put tenants not found response has a 5xx status code
func (o *PutTenantsNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this put tenants not found response a status code equal to that given
func (o *PutTenantsNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the put tenants not found response
func (o *PutTenantsNotFound) Code() int {
	return 404
}

func (o *PutTenantsNotFound) Error() string {
	return fmt.Sprintf("[PUT /tenants][%d] putTenantsNotFound  %+v", 404, o.Payload)
}

func (o *PutTenantsNotFound) String() string {
	return fmt.Sprintf("[PUT /tenants][%d] putTenantsNotFound  %+v", 404, o.Payload)
}

func (o *PutTenantsNotFound) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PutTenantsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutTenantsUnprocessableEntity creates a PutTenantsUnprocessableEntity with default headers values
func NewPutTenantsUnprocessableEntity() *PutTenantsUnprocessableEntity {
	return &PutTenantsUnprocessableEntity{}
}

/*
PutTenantsUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutTenantsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *sfgate_models.Error
}

// IsSuccess returns true when this put tenants unprocessable entity response has a 2xx status code
func (o *PutTenantsUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put tenants unprocessable entity response has a 3xx status code
func (o *PutTenantsUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put tenants unprocessable entity response has a 4xx status code
func (o *PutTenantsUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this put tenants unprocessable entity response has a 5xx status code
func (o *PutTenantsUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this put tenants unprocessable entity response a status code equal to that given
func (o *PutTenantsUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the put tenants unprocessable entity response
func (o *PutTenantsUnprocessableEntity) Code() int {
	return 422
}

func (o *PutTenantsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /tenants][%d] putTenantsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutTenantsUnprocessableEntity) String() string {
	return fmt.Sprintf("[PUT /tenants][%d] putTenantsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutTenantsUnprocessableEntity) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PutTenantsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutTenantsInternalServerError creates a PutTenantsInternalServerError with default headers values
func NewPutTenantsInternalServerError() *PutTenantsInternalServerError {
	return &PutTenantsInternalServerError{}
}

/*
PutTenantsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PutTenantsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *sfgate_models.Error
}

// IsSuccess returns true when this put tenants internal server error response has a 2xx status code
func (o *PutTenantsInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put tenants internal server error response has a 3xx status code
func (o *PutTenantsInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put tenants internal server error response has a 4xx status code
func (o *PutTenantsInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this put tenants internal server error response has a 5xx status code
func (o *PutTenantsInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this put tenants internal server error response a status code equal to that given
func (o *PutTenantsInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the put tenants internal server error response
func (o *PutTenantsInternalServerError) Code() int {
	return 500
}

func (o *PutTenantsInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /tenants][%d] putTenantsInternalServerError  %+v", 500, o.Payload)
}

func (o *PutTenantsInternalServerError) String() string {
	return fmt.Sprintf("[PUT /tenants][%d] putTenantsInternalServerError  %+v", 500, o.Payload)
}

func (o *PutTenantsInternalServerError) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PutTenantsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
